#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <sstream>
#include <string>
#include "menu.h"
using namespace std;

Menu::Menu(){
	menu=0;
	numOpciones=0;
	salir=false;
}

void Menu::navegarMenu(){
	int opcion;
	bool tipo;
	estandarOp.setJuego(0);
	do{
		system("clear");
		cout << endl << endl;
		mostrarMenu();
		cout << "\n\n     Elija una opción: ";
		cin >> opcion;
		tipo=isOpcion(opcion);
		if(tipo==true)
			ejecutarOpcion(opcion);
	}while(salir==false && estandarOp.isJuego(0));
}

bool Menu::isOpcion(int opcion){
	bool tipo=false;
	if(opcion>0 && opcion<=numOpciones)
		tipo=true;
	return tipo;
}

void Menu::ejecutarOpcion(int opcion){
	int num;
	opcion=menu*10+opcion;
	switch(opcion){
		case 4:	//salir
			salir=true;
			break;
		case 15: //volver a menu principal
		case 23:
		case 36:
			menu=0;
			break;
		case 113: //volver al menu jugar
		case 126:
		case 136:
		case 148:
			menu=1;
			break;
		case 111: //jugar juego opcion
			estandarOp.setTipo(false);
			estandarOp.setJuego(menu%10);
			estandarOp.setMinNivel(minNivel);
			estandarOp.setMaxNivel(maxNivel);
			estandarOp.setAciertosNivel(2);
			break;
		case 121: //jugar torneo
		case 122:
		case 123:
		case 124:
		case 125:
			if(estandarOp.isDesbloqueado(opcion%10)){
				estandarOp.setJuego(menu%10);
				estandarOp.setTorneo(opcion%10);
				estandarOp.setTipo(true);
				estandarOp.setMinNivel(opcion%10);
				estandarOp.setMaxNivel(opcion%10);
			}
			break;
		case 131:
		case 132:
		case 133:
		case 134:
		case 135:
			estandarOp.setJuego(menu%10);
			estandarOp.setTorneo(opcion%10);
			estandarOp.setTipo(true);
			estandarOp.setAciertosNivel(10);
			if(opcion%10<=4){
				estandarOp.setMinNivel(2);
				estandarOp.setMaxNivel(3);
			}else{
				estandarOp.setMinNivel(4);
				estandarOp.setMaxNivel(5);
			}
			break;
		case 112:
			estandarOp.setTiempo();
			break;
		case 141:
			personalizado.setJuego(menu%10);
			estandarOp.setJuego(menu%10);
			break;
		case 142:
			personalizado.setTipo();
			break;
		case 143:
			if(personalizado.isTipo()){
				personalizado.setNumOperaciones();
			}else{
				personalizado.setTiempo();
			}
			break;
		case 144:
			personalizado.setMinNivel();
			break;
		case 145:
			personalizado.setMaxNivel();
			break;
		case 146:
			personalizado.setAciertosNivel();
			break;
		case 147:
			personalizado.setRepetir();
			break;
		case 21:
			estandarOp.setSonido();
			personalizado.setSonido();
			break;
		case 22:
			estandarOp.setTiempo();
			break;
		case 31:
		case 32:
		case 33:
		case 34:
			do{
				system("clear");
				menu=opcion;
				cout << "\n\n";
				mostrarMenu();
				mostrarPuntuaciones(opcion%10);
			}while(menu!=1);
			menu=3;
			break;
		case 35:
			borrarPuntuaciones();
			break;
		default:
			menu=opcion;
	}
}


void Menu::mostrarMenu(){
	int num;
	int opciones=0;
	string file="menu";
	string line, texto, opcion;
	ifstream fi;
	fi.open(file.c_str(), ios::in);
	if (fi.is_open()){
		getline(fi,line);
		while (!fi.eof()){
			num=extraerNumero(line, 0);
			if(num==menu){
				texto=extraerCadena(line, 1);
				cout << "     "<<texto;
				opcion=extraerCadena(line, 2);
				opcion=interpretarOpcion(opcion);
				cout <<"     "<< opcion << endl;
				opciones++;
			}
			getline(fi,line);
		}
		numOpciones=opciones-4;
		fi.close();
	}
}

void Menu::mostrarPuntuaciones(int menuPuntos){
	int i, num;
	int opciones=0;
	int contador=0;
	string file="puntuaciones";
	string line, texto, opcion, espacios;
	ifstream fi;
	fi.open(file.c_str(), ios::in);
	if (fi.is_open()){
		getline(fi,line);
		cout << "\n     Posición      Puntos/seg      Puntos          Fecha\n";
		while (!fi.eof()){
			num=extraerNumero(line, 0);
			if(num==menuPuntos){
				contador++;
				cout << "        "<< contador << ".";
				texto=extraerCadena(line, 1);
				i=1;
				if(contador>9)
					i++;
				for(i;i<(17-texto.length());i++){
					cout << ' ';
				}
				cout << texto;
				opcion=extraerCadena(line, 2);
				for(i=1;i<(15-opcion.length());i++){
					cout <<' ';
				}
				cout<< opcion << endl;
			}
			getline(fi,line);
		}
		cout << "\n     1. Volver: ";
		cout << "\n     Elija una opción: ";
		cin >> menu;
		numOpciones=opciones-4;
		fi.close();
	}
}

string Menu::interpretarOpcion(string opcion){
	stringstream temp;
	string texto, temporal;
	if(opcion=="tiempo")
		temp << "< " << estandarOp.getTiempo() << " >";
	else if(opcion=="sonido"){
		if(personalizado.isSonido())
			temp << "< Activado >";
		else
			temp << "< desactivado >";
	}else if(opcion=="")
		temp<<"";
	else if(opcion=="minN")
		temp << "< "<< personalizado.getMinNivel() << " >";
	else if(opcion=="maxN")
		temp << "< "<< personalizado.getMaxNivel() << " >";
	else if(opcion=="aciertosNivel"){
		if(personalizado.getMaxNivel()==personalizado.getMinNivel())
			temp << "< Bloqueado >";
		else
			temp << "< "<< personalizado.getAciertosNivel() << " >";
	}else if(opcion=="repetir"){
		if(personalizado.isRepetir())
			temp << "< Activado >";
		else
			temp << "< Desactivado >";
	}else if(opcion=="tipo"){
		if(personalizado.isTipo())
			temp << "< Operaciones >";
		else
			temp << "< Tiempo >";
	}else if(opcion=="cantidad"){
		if(personalizado.isTipo())
			temp << "< " << personalizado.getNumOperaciones() << " >";
		else
			temp << "< " << personalizado.getTiempo() << " >";
	}else{
		temporal=opcion.substr(1);
		if(temporal=="bloqueado"){
			if(!estandarOp.isDesbloqueado(convertirEntero(opcion[0])))
				temp << "< Bloqueado >";
		}else
				temp << "< No definido >";
	}

	texto=temp.str();
	return texto;
}

bool Menu::isSalir(){
	return salir;
}

string Menu::extraerCadena(string cadena, int pos){
	int i;
	int unsigned ini=0;
	int unsigned end=0;
		for (i=0;i<=pos;i++){
			if(end!=cadena.length()){
				if(end!=0)
					ini=end+1;
				if(cadena.find('#', ini)==string::npos)
					end=cadena.length();
				else
					end=cadena.find('#', ini);
			}else
				cadena="";
		}
	if(cadena!="")
			cadena=cadena.substr(ini, end-ini);
	return(cadena);
}

int Menu::extraerNumero(string cadena, int pos){
	int num;
	string texto;
	texto=extraerCadena(cadena, pos);
	num=atoi(texto.c_str());
	return num;
}




void Menu::borrarPuntuaciones(){

}

Opciones Menu::getOpciones(){
	Opciones opciones;
	if(estandarOp.isJuego(4))
		opciones=personalizado;
	else
		opciones=estandarOp;
		return opciones;
}

void Menu::setOpciones(Opciones menu){
	if(!estandarOp.isJuego(4))
		estandarOp=menu;
}

int Menu::convertirEntero(string texto){
	int num;
	num=atoi(texto.c_str());
	return num;
}

int Menu::convertirEntero(char texto){
	int num;
	num=texto-48;
	return num;
}
